package com.sillycycle.bagleyd.welltris;

/*
 * @(#)Thing.java
 *
 * Copyright 1993 - 2014  David A. Bagley, bagleyd AT verizon.net
 *
 * Taken from GENERIC X-BASED TETRIS
 *
 * Copyright 1992 - 1995 Q. Alex Zhao, azhao AT cc.gatech.edu
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

import android.graphics.Point;

/**
 * The <code>Thing</code> class keeps track of the falling shapes.
 *
 * @author	David A. Bagley
 * @author	bagleyd AT verizon.net
 * @author	https://www.sillycycle.com/altris.html
 */

public class Thing {
	int             units, polyNumber;
	Point           position = new Point(0, 0);
	int             size, colorNumber, direction;
	private int     randomRotation, randomReflection;
	private int     randomNumber;
	private boolean bonus;

	void clone(Thing nextThing) {
		units = nextThing.units;
		polyNumber = nextThing.polyNumber;
		position.x = nextThing.position.x;
		position.y = nextThing.position.y;
		size = nextThing.size;
		colorNumber = nextThing.colorNumber;
		direction = nextThing.direction; // hextris & tertris
		bonus = nextThing.bonus;
		randomRotation = nextThing.randomRotation;
		randomReflection = nextThing.randomReflection;
		randomNumber = nextThing.randomNumber;
	}

	void setRandomNumber(int number) {
		randomNumber = number;
	}

	int getRandomNumber() {
		return randomNumber;
	}

	void setRotation(int rotation) {
		randomRotation = rotation;
	}

	int getRotation() {
		return randomRotation;
	}

	void setReflection(int reflection) {
		randomReflection = reflection;
	}

	int getReflection() {
		return randomReflection;
	}

	void setBonus(boolean b) {
		bonus = b;
	}

	boolean getBonus() {
		return bonus;
	}
}
